; by kero

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32
inclib uxtheme

.const
 id                    equ 100
 STAP_ALLOW_NONCLIENT  equ 1
 STAP_ALLOW_CONTROLS   equ 2
 STAP_ALLOW_WEBCONTENT equ 4
 WM_THEMECHANGED       equ 031Ah

.data
 _app    db "Edit Edge",0
 _edit   db "Edit",0
 _button db "Button",0
 _ft     db "%8.8lX _ %8.8lX",0
.data?
  hinst  dd ?
.code

WndProc proc uses ebx edi esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
  local buf[128]:BYTE

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0
    xor eax,eax

  .elseif uMsg==WM_CREATE

    push WS_EX_CLIENTEDGE
    push WS_CHILD or WS_VISIBLE
    push WS_EX_STATICEDGE or WS_EX_CLIENTEDGE
    push WS_CHILD or WS_VISIBLE or WS_BORDER
    push WS_EX_STATICEDGE or WS_EX_CLIENTEDGE
    push WS_CHILD or WS_VISIBLE
    push WS_EX_STATICEDGE
    push WS_CHILD or WS_VISIBLE or WS_BORDER
    push WS_EX_STATICEDGE
    push WS_CHILD or WS_VISIBLE
    push WS_EX_CLIENTEDGE
    push WS_CHILD or WS_VISIBLE or WS_BORDER
    push WS_EX_CLIENTEDGE
    push WS_CHILD or WS_VISIBLE
    push 0
    push WS_CHILD or WS_VISIBLE or WS_BORDER
    push 0
    push WS_CHILD or WS_VISIBLE
    xor esi,esi
    .while esi!=9
      pop ecx
      pop edx
      mov eax,esi
      mov bl,50
      mul bl
      add eax,20
      mov ebx,id
      add ebx,esi
      invoke CreateWindowEx,edx,addr _edit,0,ecx,20,eax,200,30,hWnd,ebx,hinst,0
      mov ebx,eax
      invoke GetWindowLong,ebx,GWL_EXSTYLE
      mov edi,eax
      invoke GetWindowLong,ebx,GWL_STYLE
      invoke wsprintf,addr buf,addr _ft,edi,eax
      invoke SetWindowText,ebx,addr buf
      inc esi
    .endw
    invoke SetWindowPos,ebx,0,240,120,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_FRAMECHANGED

    invoke CreateWindowEx,0,addr _button,0,WS_CHILD or WS_VISIBLE, 20,420,200,30,hWnd,id+10,hinst,0

    invoke SetThemeAppProperties,STAP_ALLOW_NONCLIENT or STAP_ALLOW_WEBCONTENT ; 0
    invoke SendMessage,ebx,WM_THEMECHANGED,0,0    

    invoke CreateWindowEx,0,addr _button,0,WS_CHILD or WS_VISIBLE,240,420,90,30,hWnd,id+11,hinst,0

    invoke SetThemeAppProperties,STAP_ALLOW_NONCLIENT or STAP_ALLOW_CONTROLS or STAP_ALLOW_WEBCONTENT
    invoke CreateWindowEx,0,addr _button,0,WS_CHILD or WS_VISIBLE,350,420,90,30,hWnd,id+12,hinst,0
    xor eax,eax
  .else
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    .if uMsg==WM_NCHITTEST && eax==HTCLIENT
      mov eax,HTCAPTION
    .endif
  .endif
  ret
WndProc endp


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local wc:WNDCLASSEX
  local msg:MSG
  local hwnd:HWND

  mov wc.cbSize,sizeof wc
  mov wc.style,0
  mov wc.lpfnWndProc,offset WndProc
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0 ; DLGWINDOWEXTRA ; 
  mov eax,hInst
  mov wc.hInstance,eax
  mov wc.hbrBackground,COLOR_3DFACE+1
  mov wc.lpszMenuName,0
  mov wc.lpszClassName,offset _app
;  invoke LoadIcon,0,IDI_EXCLAMATION
  xor eax,eax
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  invoke RegisterClassEx,addr wc
  
  invoke CreateWindowEx,\
      WS_EX_TOPMOST or WS_EX_CLIENTEDGE or WS_EX_TOOLWINDOW,\
      offset _app, offset _app,\
      WS_POPUP or WS_SYSMENU or WS_CAPTION or WS_THICKFRAME,\
      20,20,500,500,0,0,hInst,0

  mov hwnd,eax
  invoke ShowWindow,eax,CmdShow
  invoke UpdateWindow,hwnd

  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov eax,msg.wParam
  ret
WinMain endp


start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
  invoke InitCommonControls
end start
